package cn.com.infosec.jce.provider;

import cn.com.infosec.jce.ProviderConfigurationPermission;
import cn.com.infosec.jce.spec.ECParameterSpec;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.security.Permission;

class ProviderUtil {
   private static final long MAX_MEMORY = Runtime.getRuntime().maxMemory();
   private static Permission BC_EC_LOCAL_PERMISSION = new ProviderConfigurationPermission("INFOSEC", "threadLocalEcImplicitlyCa");
   private static Permission BC_EC_PERMISSION = new ProviderConfigurationPermission("INFOSEC", "ecImplicitlyCa");
   private static ThreadLocal threadSpec = new ThreadLocal();
   private static volatile ECParameterSpec ecImplicitCaParams;

   static void setParameter(String parameterName, Object parameter) {
      SecurityManager var2 = System.getSecurityManager();
      if (parameterName.equals("threadLocalEcImplicitlyCa")) {
         if (var2 != null) {
            var2.checkPermission(BC_EC_LOCAL_PERMISSION);
         }

         ECParameterSpec parameterName1;
         if (!(parameter instanceof ECParameterSpec) && parameter != null) {
            parameterName1 = EC5Util.convertSpec((java.security.spec.ECParameterSpec)parameter, false);
         } else {
            parameterName1 = (ECParameterSpec)parameter;
         }

         if (parameterName1 == null) {
            threadSpec.remove();
         } else {
            threadSpec.set(parameterName1);
         }
      } else if (parameterName.equals("ecImplicitlyCa")) {
         if (var2 != null) {
            var2.checkPermission(BC_EC_PERMISSION);
         }

         if (!(parameter instanceof ECParameterSpec) && parameter != null) {
            ecImplicitCaParams = EC5Util.convertSpec((java.security.spec.ECParameterSpec)parameter, false);
         } else {
            ecImplicitCaParams = (ECParameterSpec)parameter;
         }
      }

   }

   static ECParameterSpec getEcImplicitlyCa() {
      ECParameterSpec var0;
      return (var0 = (ECParameterSpec)threadSpec.get()) != null ? var0 : ecImplicitCaParams;
   }

   static int getReadLimit(InputStream in) {
      if (in instanceof ByteArrayInputStream) {
         return in.available();
      } else {
         long var1;
         return (var1 = MAX_MEMORY) > 2147483647L ? Integer.MAX_VALUE : (int)var1;
      }
   }
}
